 Member
!_ABCDllMode_    Equate(0)
!_ABCLinkMode_   equate(1)

PRINTER_NOTIFY_TYPE                           Equate(00H)
JOB_NOTIFY_TYPE                               Equate(01H)
PRINTER_CHANGE_ADD_JOB                        equate(100H)
JOB_NOTIFY_FIELD_PRINTER_NAME                 Equate(00H)
JOB_NOTIFY_FIELD_MACHINE_NAME                 Equate(01H)
JOB_NOTIFY_FIELD_PORT_NAME                    Equate(02H)
JOB_NOTIFY_FIELD_USER_NAME                    Equate(03H)
JOB_NOTIFY_FIELD_NOTIFY_NAME                  Equate(04H)
JOB_NOTIFY_FIELD_DATATYPE                     Equate(05H)
JOB_NOTIFY_FIELD_PRINT_PROCESSOR              Equate(06H)
JOB_NOTIFY_FIELD_PARAMETERS                   Equate(07H)
JOB_NOTIFY_FIELD_DRIVER_NAME                  Equate(08H)
JOB_NOTIFY_FIELD_DEVMODE                      Equate(09H)
JOB_NOTIFY_FIELD_STATUS                       Equate(0AH)
JOB_NOTIFY_FIELD_STATUS_STRING                Equate(0BH)
JOB_NOTIFY_FIELD_SECURITY_DESCRIPTOR          Equate(0CH)
JOB_NOTIFY_FIELD_DOCUMENT                     Equate(0DH)
JOB_NOTIFY_FIELD_PRIORITY                     Equate(0EH)
JOB_NOTIFY_FIELD_POSITION                     Equate(0FH)
JOB_NOTIFY_FIELD_SUBMITTED                    Equate(10H)
JOB_NOTIFY_FIELD_START_TIME                   Equate(11H)
JOB_NOTIFY_FIELD_UNTIL_TIME                   Equate(12H)
JOB_NOTIFY_FIELD_TIME                         Equate(13H)
JOB_NOTIFY_FIELD_TOTAL_PAGES                  Equate(14H)
JOB_NOTIFY_FIELD_PAGES_PRINTED                Equate(15H)
JOB_NOTIFY_FIELD_TOTAL_BYTES                  Equate(16H)
JOB_NOTIFY_FIELD_BYTES_PRINTED                Equate(17H)


!thread related
Infinite          equate( -1 )
Wait_object_0     equate( 0 )    !is signaled, busy
Wait_TimeOut      equate( 102H ) !not signaled, reset, not busy
Wait_Failed       equate( -1 )   !error - bad handle usually
Create_Suspended  equate( 4 ) 

!job status codes
JOB_STATUS_PAUSED               Equate(001H)
JOB_STATUS_ERROR                Equate(002H)
JOB_STATUS_DELETING             Equate(004H)
JOB_STATUS_SPOOLING             Equate(008H)
JOB_STATUS_PRINTING             Equate(010H)
JOB_STATUS_OFFLINE              Equate(020H)
JOB_STATUS_PAPEROUT             Equate(040H)
JOB_STATUS_PRINTED              Equate(080H)
JOB_STATUS_BLOCKED_DEVQ         equate(200H)
JOB_STATUS_DELETED              Equate(100H)
JOB_STATUS_USER_INTERVENTION    Equate(400H)
JOB_STATUS_RESTART              Equate(800H)

JOB_CONTROL_PAUSE              equate( 1 )
JOB_CONTROL_RESUME             equate( 2 )
JOB_CONTROL_CANCEL             equate( 3 )
JOB_CONTROL_RESTART            equate( 4 )
JOB_CONTROL_DELETE             equate( 5 )
JOB_CONTROL_SENT_TO_PRINTER    equate( 6 )
JOB_CONTROL_LAST_PAGE_EJECTED  equate( 7 )

               
 Map
   !Local Procedures, if any, go here
   MonitorProc( long lpData ), long, pascal
   MonitorProc2( long lpData ), long, pascal
   !API Prototypes
   Module('api')
     AttachThreadToClarion (BOOL Full),PASCAL
     TerminateThread( long hThread, long exitcode ), bool, pascal, Proc
     interlockedIncrement( long ),long,pascal,raw,name('InterlockedIncrement'),proc
     interlockeddecrement( long ),long,pascal,raw,name('Interlockeddecrement'),proc
     InitializeCriticalSection( long lpCriticalSection ),PASCAL,RAW
     DeleteCriticalSection( long lpCriticalSection ),PASCAL,RAW
     EnterCriticalSection( long lpCritical_Sectiontype ),PASCAL,RAW
     LeaveCriticalSection( long lpCritical_Sectiontype ),PASCAL,RAW
     dbsend( *cstring pmsg ),pascal,raw,name('outputdebugstringa')
     Sleep( long pMilliSeconds ), Pascal
     CreateEvent( long lpSecurityAttributes=0, long bManualReset, long bIntiallySignaled, Long lpszName ), long, pascal, Name('CreateEventA')
     CreateThread( long lpSecurityAttributes=0, long pStackSize=0, long pStartAddress, long plpData, long pdwFlags, *long pThreadID ), long, pascal, Name('CreateThread')
     CloseHandle( long phandle ),bool,pascal,proc
     SetEvent( long phEvent ), bool, pascal,proc
     ResetEvent( long phEvent ), bool, pascal,proc
     ResumeThread( long phThread ), long, pascal,proc
     WaitForSingleObject( long pHandle, long dwMilliSeconds ), Long, pascal, Name('WaitForSingleObject'),proc
     WaitForMultipleObjects( long pCount, long lpHandleArray, long bWaitForAll, long dwMilliSeconds ), long, pascal, Name('WaitForMultipleObjects'), proc
     FormatMessage( ulong,long,ulong,ulong,long,ulong,long),ulong,PASCAL,RAW,Name('FormatMessageA')
     LocalFree( long ),long,PASCAL,proc
     memcpy( long lpDestination, long lpSource, long cbBlock ),long,name('_memcpy'),proc
     getlasterror(),ulong,pascal,name('getlasterror')
     lstrcpy( long lpszDestination ,long lpszSource ),long,pascal,raw,name('lstrcpya'),proc
     lstrcpyn( long lpszDestination, long lpszSource, long cbSizeDestination ), long,pascal,raw,name('lstrcpyna') !last param includes terminal null
     lstrlen( long lpszString ),long, pascal,raw,name('lstrlena'),proc
     memcmp( long lpblock1 ,long lpBlock2, long cbBlock ),long,name('_memcmp')
     memset( long lpBlock, byte pValueToWrite, long cbBlock ),long,proc,name('_memset')
     WriteProfileString(*cstring,*cstring,*cstring),BOOL,PASCAL,RAW,NAME('WriteProfileStringA')
     GetProfileString(*cstring,*cstring,*cstring,long,long),long,PASCAL,RAW,NAME('GetProfileStringA')
     _lclose(unsigned),unsigned,PASCAL,proc
     _lopen(*cstring,SIGNED),unsigned,PASCAL,RAW
     _lread(unsigned, long, ushort),short,PASCAL,RAW
     GetProfileString(*cstring,*cstring,*cstring,*cstring,ulong),ulong,PASCAL,RAW,NAME('GetProfileStringA')
     OpenPrinterA(*cstring,long,long=0),BOOL,PASCAL,RAW
     ClosePrinter(Unsigned),BOOL,PASCAL,proc
     StartDocPrinterA(unsigned,ulong,long),ulong,PASCAL,proc
     EndDocPrinter(unsigned),BOOL,PASCAL,proc
     WritePrinter(unsigned,long,ulong,*ulong),BOOL,PASCAL,RAW,proc
     EndPagePrinter(unsigned),BOOL,PASCAL,proc
     StartPagePrinter(unsigned),BOOL,PASCAL,proc
     EnumPrintersA(ulong,*cstring,ulong,long,ulong,Long,long),BOOL,PASCAL,RAW
     GlobalAlloc(UNSIGNED,ulong),unsigned,PASCAL
     GlobalFree(unsigned),unsigned,PASCAL,proc
     GlobalLock(unsigned),long,pascal,raw
     EnumJobs(unsigned, ulong, ulong, ulong, long, ulong, long, long),bool,pascal,raw,name('EnumjobsA')
     SetJob( long hprinter, long jobid, long InfoLevel=0, long lpJobData=0, long Job_control_Command ), Bool, pascal, proc, raw, Name( 'SetJobA' )
     GetTimeZoneInformation(long),ulong,PASCAL,RAW,proc
     GetPrinter(unsigned, ulong, long, ulong, long),bool,pascal,raw,name('GetPrinterA')
     SetPrinter(unsigned, ulong, long, ulong),bool,pascal,raw,name('setPrinterA')
     GetVersionExA(Long),BOOL,PASCAL,RAW
     SendMessage(unsigned, unsigned, Unsigned,long),bool,pascal,raw,name('sendmessageA'),proc
     !in winspool.drv
     FindFirstPrinterChangeNotification( long hPrinter, long DwFlags, long Reserved=0, long lpPrinterNotifyOptions ), long, pascal, raw, proc, Name('FindFirstPrinterChangeNotification')
     FindClosePrinterChangeNotification( long hwait ),Bool, pascal, proc, raw, Name('FindClosePrinterChangeNotification')
     FindNextPrinterChangeNotification( long hwait, long lpDwChange, long lpPrinterNofityOptions, *long lpPrinterNotifyInfo ), bool, pascal, raw, Proc, Name('FindNextPrinterChangeNotification')
     FreePrinterNotifyInfo( long lpPrinterNotifyInfo ),Bool, pascal,proc,Name('FreePrinterNotifyInfo')
     
   End
 end

!Includes this class and others
 include('EnumPtr.inc')

!global data for this module
Return:Benign equate(0)
Return:Fatal  equate(3)
Return:Notify equate(5)

PrinterNotificationsQType   queue,Type
hprinter    long
hThread     long
Printername cstring(256)
   end

!-------------------------------------------------------------
!---Start of EnumPtr class
!-------------------------------------------------------------
EnumPrtClType.Init                  Procedure( byte pDebugMode = 0)
OSVERSIONINFO          GROUP
dwOSVersionInfoSize      ULong
dwMajorVersion           ULong
dwMinorVersion           ULong
dwBuildNumber            ULong
dwPlatformId             ULong
szCSDVersion             String(128)
                        END
  Code
  If pDebugMode then
    SELF.DebugMode = true
  else
    SELF.DebugMode = False
  end
  SELF.PrinterQueue &= New(PrinterQueueType)
  If SELF.PrinterQueue &= Null then stop('Unable to allocate Printer Queue').

  !Is this NT?
  SELF.IsNT=False
  OsVersionInfo.dwOSVersionInfoSize = Size(OSVERSIONInfo)
  If GetVersionEXA(Address(OSVersionInfo))
     If OSVersionInfo.dwPlatformID=2 then
       SELF.IsNT = True
     end
  end
  Return

EnumPrtClType.Kill              Procedure()
!!destroy any dynamic objects and clean up
    Code
    SELF.KillNotifications()
    If ~SELF.PrinterQueue &= Null then
      Dispose(SELF.PrinterQueue)
    end
    RETURN
    
EnumPrtClType.OpenPrinter Procedure(*cstring defaultPrinter, long lphprinter, long pAccessRights=Printer_All_Access)
!opens the printer with the requested access
! 2nd parameter is an address
! returns 0 on failure, non-zero on success
Printer_Defaults    group
pDataType           long
pDevMode            long
Access_Mask         long
            end

lpPrinter_Defaults    long,auto
  code
  Printer_Defaults.Access_Mask = pAccessRights
  If SELF.isNT then
    lpPrinter_Defaults = Address(Printer_Defaults)
  else
    lpPrinter_Defaults = 0
  end
  Return OpenPrinterA(defaultPrinter,lphprinter, lpPrinter_Defaults)
  

EnumPrtClType.GetDefaultPrinter  Procedure(*Cstring DefaultPrinter)
PrinterName     cstring(256),auto
printerNameAddress      LONG
isdefault               LONG
Gptr                    equate(40H) !Gmem_fixed or Gmem_ZeroInit
ERROR_INSUFFICIENT_BUFFER        EQUATE(122)    ! dderror
Printer_Enum_default    equate(1)
szPrinterInfo2          equate(84)  !bytes in printer_info_2 structure
offsetPrintername equate(4)  !offset to printer name in Printer_Info_2
offsetAttributes  equate(52) !offset to printer attributes in Printer_info_2
dwsize            ulong(0)
dwPrinters        ulong(0)
dwneeded    ulong(0)
bRC         Bool(0)
lpInfo      long(0)
dwtype      ulong(Printer_Enum_default)
dwLevel     ulong(2)
lpName              cstring(256)
startaddress        long
PrinterAttributes   long
dwErrorcode         ulong
  CODE
    iF ~SELF.GETDEFAULTPRINTERNT() THEN !TRY THE REGISTRY FIRST! WORKS FOR 95,98,NT
        DEFAULTPRINTER=SELF.DEFAULTPRINTERNT
        RETURN(1)
    END
    lpname=''
    clear(defaultprinter)  !initialize it incase we dont find one
    If SELF.isNT then 
        If SELF.GetDefaultPrinterNT() then
           Return(0)
        else
           DefaultPrinter=SELF.DefaultPrinterNT
           Return(1)
        end
    end
      
    bRC=EnumPrintersA(dwType,lpname,dwlevel,0,0,address(dwsize),address(dwprinters))
    if bRC then  !no memory allocated and no error - must not be any printers
      !message('No Printers to List','No Printers')
      return(0)
    .
    dwerrorcode=getlasterror()
    if dwerrorcode<>ERROR_INSUFFICIENT_BUFFER then  !some strange error -abort
      !message(format(dwerrorcode,@N-13),'Pass 1')
      return(0)
    .
    dwsize=128 !init to one printer plus about 44 bytes- probably too small
    loop
      lpinfo=globalalloc(gptr, dwsize)
      lpname=''   !no server name
      dwtype=Printer_Enum_default     !Printer_enum_default=1
      dwlevel=2    !type 2 structure
      dwneeded=0   !clear it - returns bytes needed to allocate
      dwprinters=0  !clear it  - returns number of printers
      if lpinfo  !if globalalloc the memory
        bRC=enumprintersA(dwType,lpname, dwlevel, lpinfo, dwsize, address(dwneeded), address(dwPrinters) )
        if ~bRC   !ther was an error if 0
          dwErrorcode=getlasterror()
          if dwerrorcode <> ERROR_INSUFFICIENT_BUFFER  !unexpected error - abort
            globalfree(lpinfo)  !free memory
            return(0)
          else !too little memory
            globalfree(lpinfo)  !free the memory
            dwsize=dwneeded     !setup to allocate the correct memory
            cycle  !allocate new amount of memory and enumprinters
          .
        else !brc - no error
          isdefault=0  !init to 0
          loop i#=1 to dwprinters
            startaddress=(i#-1)* szPrinterInfo2 + lpinfo + offsetAttributes  !address of attributes
            memcpy(address(printerattributes),startaddress,4)   !copy the attributes
            startaddress=(i#-1)* szPrinterInfo2 + lpinfo + offsetPrinterName
            memcpy(address(PrinterNameaddress),startaddress,4) !copy the address
            lstrcpy(address(printerName),printernameaddress)
            If SELF.isDefaultPrinter(Printerattributes,PrinterName)
              isdefault=1  !found it
              defaultPrinter = PrinterName
              break
            .
          .
          globalfree(lpinfo)
          break
        .
      else   !global allocation error
        return(0)
      .
    .!loop       
    return(isdefault) !Return value of 1 is good 0 is an error

EnumPrtClType.GetPrinterList  Procedure(*PrinterQueueType PrinterQueue)
printerNameAddress   LONG
isdefault            LONG
Gptr equate(40H) !Gmem_fixed or Gmem_ZeroInit
ERROR_INSUFFICIENT_BUFFER        EQUATE(122)    ! dderror
Printer_Enum_Local equate(2)
szPrinterInfo2 equate(84)  !bytes in printer_info_2 structure
offsetPrintername equate(4)  !offset to printer name in Printer_Info_2
offsetAttributes  equate(52) !offset to printer attributes in Printer_info_2
pPortName       equate(12)
dwsize      ulong(0)
dwPrinters  ulong(0)
dwneeded    ulong(0)
bRC         Bool(0)
lpInfo      long(0)
PRINTER_ENUM_CONNECTIONS Equate(4H)
dwtype                          ulong(Printer_Enum_connections+Printer_enum_local) !type of enumeration
dwLevel     ulong(2)
lpName              cstring(256)
startaddress        long
PrinterAttributes   long
dwErrorcode         ulong
  CODE                                            ! Begin processed code
    lpname=''
    If SELF.isNT then SELF.GetDefaultPrinterNT().
    bRC=EnumPrintersA(dwType,lpname,dwlevel,0,0,address(dwsize),address(dwprinters))
    if bRC then  !no memory allocated and no error - must not be any printers
      !message('No Printers to List','No Printers')
      free(printerqueue)
      return(0)
    .
    dwerrorcode=getlasterror()
    if dwerrorcode<>ERROR_INSUFFICIENT_BUFFER then  !some strange error -abort
      !message(format(dwerrorcode,@N-13),'Pass 1')
      free(printerqueue)
      return(0)
    .
    dwsize=84 !init to one printer - probably too small
    loop
      lpinfo=globalalloc(gptr, dwsize)
      lpname=''   !no server name
      dwtype=Printer_Enum_local+Printer_Enum_connections     !Printer_enum_Local=2
      dwlevel=2    !type 2 structure
      dwneeded=0   !clear it - returns bytes needed to allocate
      dwprinters=0  !clear it  - returns number of printers
      if lpinfo  !if globalalloc the memory
        bRC=enumprintersA(dwType,lpname, dwlevel, lpinfo, dwsize, address(dwneeded), address(dwPrinters) )
        if ~bRC   !ther was an error if 0
          dwErrorcode=getlasterror()
          if dwerrorcode <> ERROR_INSUFFICIENT_BUFFER  !unexpected error - abort
            globalfree(lpinfo)  !free memory
            free(printerqueue)
            return(0)
          else !too little memory
            globalfree(lpinfo)  !free the memory
            dwsize=dwneeded     !setup to allocate the correct memory
            cycle  !allocate new amount of memory and enumprinters
          .
        else !brc - no error
          isdefault=1  !init to 1 - if no default return pointer to 1st printer
          loop i#=1 to dwprinters
            clear(printerqueue)
            !copy the printer name
            startaddress=(i#-1)* szPrinterInfo2 + lpinfo + offsetPrinterName
            memcpy(address(PrinterNameaddress),startaddress,4) !copy the address
            lstrcpy(address(printerqueue.printername),printernameaddress)
            !copy the port name
            startaddress=(i#-1)* szPrinterInfo2 + lpinfo + pPortName
            memcpy(address(PrinterNameaddress),startaddress,4) !copy the address
            lstrcpy(address(printerqueue.showname),printernameaddress)
            printerqueue.showname=clip(printerqueue.printername) & ' on ' & clip(printerqueue.showname)
            add(printerqueue)
            startaddress=(i#-1)* szPrinterInfo2 + lpinfo + offsetAttributes  !address of attributes
            memcpy(address(printerattributes),startaddress,4)   !copy the attributes
            if SELF.isDefaultPrinter(Printerattributes,PrinterQueue.PrinterName)
              isdefault=records(printerqueue)
            .
          .
          globalfree(lpinfo)
          break
        .
      else   !global allocation error
        free(printerqueue)
        return(0)
      .
    .!loop
    If SELF.isNT and ~isDefault and SELF.DefaultPrinterNT then
       PrinterQueue.PrinterName = SELF.DefaultPrinterNT
       PrinterQueue.ShowName = SELF.defaultPrinterNT
       Add(PrinterQueue)
       isDefault=Records(PrinterQueue)
    end
    return(isdefault)

EnumPrtClType.DirectPrtBlock Procedure(byte PopPrtDlg=1,<*Cstring PrinterName>, Long lpdata, Long datalen ,byte PrtFF=1)
hprinter     Unsigned
DOCINFO_1    GROUP
lpszDocName  LONG!*LPCSTR
lpszOutput   LONG!*LPCSTR
lpszDataType LONG!*LPCSTR
            END
dwjob       ulong
dwbytesWritten ulong
pdocname    cstring(80)
pdatatype   cstring(80)
onebyte     byte
dwJunk      ulong
DefaultPrinter cstring(128)
res byte
  CODE                                            ! Begin processed code
!Copyright Jim Kane, all rights reserved world wide
!Source may not be redistributed
    If PopPrtDlg then
      Res = SELF.PopPrtDlg(defaultprinter)
      If Res<>Return:Benign then
         !user canceled or error - in any case, return no print
         Return(res)
       end
     else
        !See if a printer name was passed
        If omitted(2) then
          If ~SELF.GetDefaultPrinter(DefaultPrinter)
            message('Error opening the printer - Printer Not Found','Printer Open Error')
            Return(Return:Fatal) !Error no printers
          end
        else
          DefaultPrinter = PrinterName
        end
     end
        if ~SELF.openPrinter(defaultprinter,address(hprinter))
          message('Error opening the printer - Printer Busy','Printer Open Error')
          return(Return:Fatal)
        .
        SELF.LastPrinterUsed = DefaultPrinter
        clear(docinfo_1)
        pdocname='Direct'
        docinfo_1.lpszdocname = address(pdocname)
        docinfo_1.lpszOutput =  0
        pdatatype='RAW'
        docinfo_1.lpszdatatype = pdatatype
        dwjob=startdocprinterA(hprinter,1, address(docinfo_1))
        if ~dwjob then
          closeprinter(hprinter)
          return(Return:Fatal)
        .
        if ~startpageprinter(hprinter) then
          EndDocPrinter(hprinter)
          closeprinter(hprinter)
          return(Return:Fatal)
        .
        onebyte=13 !cr
        writeprinter(hprinter,address(onebyte),1,dwbyteswritten)
        if ~writeprinter(hprinter,lpdata,datalen,dwbyteswritten)
          dwbyteswritten=0 !errors
        .
        if prtff
          OneByte=12
          writeprinter(hprinter,address(onebyte),1,dwJunk)
        .


        !close down
        !if dwbyteswritten then message(format(dwbyteswritten,@N-6)&' bytes written','shut down').
        EndPagePrinter(hprinter)
        EndDocPrinter(hprinter)
        closeprinter(hprinter)
        return(Return:Benign)

EnumPrtClType.DirectPrtFile   Function(byte PopPrtDlg=1,<*Cstring PrinterName>, *Cstring fname, byte prtff=1)
hprinter     unsigned
DOCINFO_1    GROUP
lpszDocName  LONG!*LPCSTR
lpszOutput   LONG!*LPCSTR
lpszDataType LONG!*LPCSTR
            END
dwjob       ulong
dwbytesWritten ulong
pdocname    cstring(80)
pdatatype   cstring(80)
FHANDLE SIGNED(0)
STARTEXT ULONG
BYTESREAD USHORT
bytestoread ushort
result ulong
buffersize equate(400H)
filebuffer byte,dim(buffersize)
defaultPrinter cstring(128)
Res byte,auto
  CODE                                            ! Begin processed code
    If PopPrtDlg then
      Res= SELF.PopPrtDlg(defaultprinter)
      If res<>Return:Benign then
         !user canceled or error - in any case, return no print
         Return(Res)
       end
     else
        !See if a printer name was passed or not
        If omitted(2) then
          If ~SELF.GetDefaultPrinter(DefaultPrinter)
            message('Error opening the printer - Printer Not Found','Printer Open Error')
            Return(Return:Fatal) !Error no printers
          end
        else
          DefaultPrinter = PrinterName
        end
      end

    fhandle=_lOpen(fname,40H) !open read, share
    if fhandle<0 then
      message('Unable to open the file for printing. Aborting!','Open File Error',icon:hand,button:ok)
      return(Return:Fatal)
    .
        if ~SELF.openPrinter(defaultprinter,address(hprinter))
          message('Error opening the printer - Printer Busy','Printer Open Error')
          If fhandle then _lclose(fhandle).
          return(Return:Fatal)
        .
        SELF.LastPrinterUsed = DefaultPrinter
        clear(docinfo_1)
        pdocname='Direct'
        docinfo_1.lpszdocname = address(pdocname)
        docinfo_1.lpszOutput =  0
        pdatatype='RAW'
        docinfo_1.lpszdatatype = pdatatype
        dwjob=startdocprinterA(hprinter,1, address(docinfo_1))
        if ~dwjob then
          If fhandle then _lclose(fhandle).
          closeprinter(hprinter)
          return(Return:Fatal)
        .
        if ~startpageprinter(hprinter) then
          EndDocPrinter(hprinter)
          closeprinter(hprinter)
          If fhandle then _lclose(fhandle).
          return(Return:Fatal)
        .
        filebuffer[1]=13 !cr
        writeprinter(hprinter,address(filebuffer),1,dwbyteswritten)
        loop !thru file
          clear(dwByteswritten)
          bytesread=_LRead(fhandle,Address(filebuffer),buffersize)
          if bytesread
            if ~writeprinter(hprinter,address(filebuffer),bytesread,dwbyteswritten)
              dwbyteswritten=0 !errors
            .
            if ~dwbyteswritten then
              message('Error Sending to Printer.','Aborting',icon:hand,button:ok)
              break
            .
          .
          if bytesread<buffersize then
            if prtff
              filebuffer[1]=12
              bytesread=1
              bytesread=writeprinter(hprinter,address(filebuffer),bytesread,dwbyteswritten)
            .
            break
          .
        .!loop thru file
        _lclose(fhandle)
        if dwbyteswritten then dwbyteswritten=1.  !return a byte count of 1
        !close down
        !if dwbyteswritten then message(format(dwbyteswritten,@N-6)&' bytes written','shut down').
        EndPagePrinter(hprinter)
        EndDocPrinter(hprinter)
        closeprinter(hprinter)
        return(Return:Benign)

EnumPrtClType.PopPrtDlg Procedure(*cstring PrinterName)
window WINDOW('Pick a Printer'),AT(,,185,92),FONT('Arial',10,,FONT:bold),SYSTEM,GRAY,RESIZE,MDI
       LIST,AT(15,7,156,14),USE(?List1),FORMAT('1020L(1)|_M~Show Name~@s255@'),DROP(10),FROM(SELF.PrinterQueue)
       BUTTON('OK'),AT(77,65),USE(?Button1)
     END
DefaultPrinterIdx long,auto
Res               byte(Return:notify) !Default to user cancel
     code
     Free(SELF.PrinterQueue)
     DefaultPrinterIdx = SELF.GetPrinterList(SELF.PrinterQueue)
     If ~DefaultPrinterIdx or ~Records(SELF.PrinterQueue) then Return(0). !error if no printers
     Open(Window)
     Display()
     SELECT(?List1,DefaultPrinterIDX)
     Accept
       Case Event()
       Of Event:Accepted
         If Field()=?Button1 then
           Res=Return:Fatal
           Get(SELF.PrinterQueue,Choice(?list1))
           If not errorcode() then
             PrinterName = SELF.PrinterQueue.PrinterName
             Res = Return:Benign !no error - printer picked
             Post(Event:CloseWindow)
           end
         end
       end
     end
     Return(Res)

EnumPrtClType.GethPrinter       procedure(byte PopPrtDlg, *cstring PrinterName)!,unsigned !hprinter is return or 0 on error
hPrinter unsigned
Res      byte,auto
  code
  If PopPrtDlg then
    Res = SELF.PopPrtDlg(printerName)
    If Res<>Return:Benign then
       !user canceled or error - in any case, return no print
       Return(0)
    end
  else
    !See if a printer name was passed
    If ~PrinterName then
      If ~SELF.GetDefaultPrinter(PrinterName)
        message('Error opening the printer - Printer Not Found','Printer Open Error')
        Return(0) !Error no printers
      end
    end
  end
  if ~SELF.openPrinter(PrinterName,address(hprinter))
    message('Error opening the printer - Printer Busy','Printer Open Error')
    return(0)
  End
  Return(hPrinter)

EnumPrtClType.EnumJobs            Procedure(byte PopPrtDlg=1,<*Cstring xPrinterName>, jobQType jobQ)
PrinterName cstring(256),auto    !name to the printer to get job status for
res         byte(Return:benign)  !result code for the procedure
hPrinter    unsigned(0)          !handle to the printer
cbNeeded    ulong,auto           !bytes needed
cReturned   ulong,auto           !Number of Job Info structures return
NoErrorEnumJobs bool,auto            !Result of EnumJobs Api Call
JOB_INFO_2  &Job_Info_2Type      !pointer to the job_Info_2 structure
ErrorEnumJobs Ulong,auto         !GetlastError code for EnumJobs call
hGlobal     signed(0)            !handle to global memory alocated - must be freed
lpglobal    long,auto            !fixed address handle for the global block
I           long,auto            !junk index var

LenStatus                       long,auto !tracks number of bitmaps added to status
ClaDate                         long,auto
ClaTime                         long,auto
SYSTEMTIME      GROUP,TYPE              !System time struct
wYear            ushort
wMonth           ushort
wDayOfWeek       ushort
wDay             ushort
wHour            ushort
wMinute          ushort
wSecond          ushort
wMilliseconds    ushort
                END
TIME_ZONE_INFORMATION   GROUP
Bias                    LONG
StandardName             byte,dim(64) !will clear to 0's
StandardDate             LIKE(systemTIME)
StandardBias             LONG
DaylightName             byte,dim(64)
DaylightDate             LIKE(SYSTEMTIME)
DaylightBias             LONG
                        END
TZ_Info                 long,auto
Bias                    long,auto



  code
  !Open a printer - return a hprinter for inputvalues of popPtrDlg, printername
  If omitted(2) then clear(printerName) Else PrinterName = xPrinterName.
  hPrinter = SELF.GethPrinter(PopPrtDlg, PrinterName)
  If ~hprinter then return(Return:Fatal).

  !See how bigger buffer is needed
  Clear(cbNeeded);clear(cReturned)
  NoErrorEnumJobs = EnumJobs(hPrinter, |        !// handle to printer object
                         0,|                !FirstJob to enum
                         1000,|             !Number of jobs to enum
                         2, |               !level of info structure = 2
                         0,|                !Address of a buffer to hold data
                         0,|                !Size of buffer
                         address(cbNeeded),|!bytes needed
                         Address(cReturned) )!# of groups returned
  If NoErrorEnumJobs or ~cbNeeded then
    !no error reported even though no memory allocated - means no jobs
    Res =Return:Notify !no jobs
    do ProcedureReturn
  end

  !Get the error - should be insufficent buffer
  ErrorEnumJobs = GetLastError()

  !If the problem is no memory, allocate some and try again
  If ErrorEnumJobs = 122 !Error code of insufficent buffer then
    hGlobal = GlobalAlloc(42H,cbNeeded)
    If ~hglobal then res=Return:Fatal;do procedureReturn.
    lpGlobal = GlobalLock(hglobal)
    If ~lpGlobal then res=Return:Fatal;do procedureReturn.
    NoErrorEnumJobs = EnumJobs(hPrinter, |        !// handle to printer object
                         0,|                !FirstJob to enum
                         1000,|             !Number of jobs to enum
                         2, |               !level of info structure = 2
                         lpGlobal,|                !Address of a buffer to hold data
                         cbNeeded,|                !Size of buffer
                         address(cbNeeded),|!bytes needed
                         Address(cReturned) )!# of groups returned
  Else
    Res = Return:Fatal !unknown error
    Clear(NoErrorEnumJobs)
  end

  !if the second call worked (non-zero) result then process the data, if any
  If NoErrorEnumJobs then
    !process the result(s)
    Loop I= 1 to cReturned

      !Set the group pointer
      Job_Info_2 &= (lpGlobal)

      Clear(JobQ)
      !Get the doc name
      SELF.CopyString(JobQ.DocName,Job_Info_2.pDocument)


      !Get status
      If Job_Info_2.pStatus then
        SELF.CopyString(JobQ.TheStatus,Job_Info_2.pStatus)
      Else
        Clear(LenStatus)
        If Band( Job_Info_2.Status,JOB_STATUS_PAUSED) ! Equate(001H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'Paused'
          LenStatus+=1
        end
        If Band( Job_Info_2.Status, JOB_STATUS_ERROR)  ! Equate(002H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'Error'
          LenStatus+=1
        end
        If Band( Job_Info_2.Status, JOB_STATUS_DELETING)  !Equate(004H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'Deleting'
          LenStatus+=1
        end
        If Band( Job_Info_2.Status, JOB_STATUS_SPOOLING)  ! Equate(008H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'Spooling'
          LenStatus+=1
        end
        If Band( Job_Info_2.Status, JOB_STATUS_PRINTING)  ! Equate(010H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'Printing'
          LenStatus+=1
        end
        If Band( Job_Info_2.Status, JOB_STATUS_OFFLINE)   ! Equate(020H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'OffLine'
          LenStatus+=1
        end
        If Band( Job_Info_2.Status, JOB_STATUS_PAPEROUT)  ! Equate(040H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'Out of Paper'
          LenStatus+=1
        end
        If Band( Job_Info_2.Status, JOB_STATUS_PRINTED)   ! Equate(080H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'Completed'
          LenStatus+=1
        end
        If Band( Job_Info_2.Status, JOB_STATUS_DELETED)   ! Equate(100H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'Deleted'
          LenStatus+=1
        end
        If Band( Job_Info_2.Status, JOB_STATUS_BLOCKED_DEVQ) !  Equate(200H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'Blocked'
          LenStatus+=1
        end
        If Band( Job_Info_2.Status, JOB_STATUS_USER_INTERVENTION)  !  Equate(400H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'User Intervention Required'
          LenStatus+=1
        end
        If Band( Job_Info_2.Status, JOB_STATUS_RESTART)   !  Equate(800H)
          JobQ.TheStatus = Clip(JobQ.TheStatus) & choose(lenStatus=0,'',' - ') & 'Restarting'
          LenStatus+=1
        end
      end

      !get Owner
      SELF.CopyString(JobQ.Owner, Job_Info_2.pUserName)

      !Get Progress
      If Job_Info_2.PagesPrinted then
        JobQ.Progress = Job_Info_2.PagesPrinted & ' of ' & Job_Info_2.TotalPages & choose(Job_Info_2.TotalPages>1,' pages',' page')
      Else
        JobQ.Progress = Job_Info_2.TotalPages & choose(Job_Info_2.TotalPages>1,' pages',' page')
      End

      TZ_Info=GetTimeZoneInformation(Address(TIME_ZONE_INFORMATION))
      Clear(Bias) !Hours from GMT
      If TZ_Info = 2 !daylight
        bias = (TIME_ZONE_INFORMATION.bias+TIME_ZONE_INFORMATION.daylightbias)/60
      Elsif tz_Info = 1 !std
        bias = (TIME_ZONE_INFORMATION.bias+TIME_ZONE_INFORMATION.Standardbias)/60
      End
      if Job_Info_2.wHour<bias then
        !borrow 24hr from the day
        Job_Info_2.WHour+=24
        Job_Info_2.wDay-=1
      end
      ClaTime = 100*(Job_Info_2.wSecond + Job_Info_2.wMinute*60 + (Job_Info_2.wHour-Bias)*3600)+1
      ClaDate = Date(Job_Info_2.wMonth,Job_Info_2.wday,Job_Info_2.wYear)
      JobQ.StartedAt = format(claTime,@T8) & ' ' & Format(ClaDate,@d2)
      !Save it
      Add(JobQ)

      !bump the pointer
      lpGlobal+=Size(Job_Info_2Type) !bump the printer
    End
  End
  do ProcedureReturn
ProcedureReturn routine
  If hprinter then closeprinter(hprinter).
  If hglobal then globalfree(hglobal).
  Return(Res)


EnumPrtClType.PauseJob procedure( long hprinter, long jobid )
!Pause a print job
! 0 = good; 3 = failure
res byte( Return:Fatal )
  code
  If SetJob( hprinter, JobID, 0, 0, JOB_CONTROL_PAUSE ) then
    Res = Return:Benign
  else
    SELF.ApiErrorCode = GetLastError()
    SELF.TakeError( 'Error Pausing a print job. ', SELF.ApiErrorCode )
  end
  Return Res
  
EnumPrtClType.ResumeJob procedure( long hprinter, long jobid )
!resume a print job - must have been previously paused
! 0 = good; 3 = failure
res byte( Return:Fatal )
  code
  If SetJob( hprinter, JobID, 0, 0, JOB_CONTROL_RESUME ) then
    Res = Return:Benign
  else
    SELF.ApiErrorCode = GetLastError()
    SELF.TakeError( 'Error restarting a print job. ', SELF.ApiErrorCode )
  end
  Return Res

EnumPrtClType.CopyString  Procedure(*string CWStr, long lpCStr)
strLen  long,auto
strsize long,auto
!Takes the address of a cstring and copies it to a cw string, as much as will fit.
!checks for null ptrs
      code
      Clear(cwStr)
      If lpCstr then !Check for null ptr
        strLen = lstrLen(lpCstr)
        If StrLen then ! Check for 0 length string
          StrSize = size(CWStr)
          StrLen = Choose(StrLen>StrSize, StrSize, StrLen) !all or as much as will fit
          Memcpy(Address(CWStr),lpCstr,StrLen)
        end
      end
      Return
      
      
EnumPrtClType.isDefaultPrinter             Procedure(long Printerattributes,*cstring PrinterName)!,byte
  code
  If SELF.isNT then
    Return SELF.isDefaultPrinterNT(printername) 
  else
    return band(Printerattributes,4)
  end
EnumPrtClType.SetDefaultPrinter            Procedure(byte PopPrtDlg=1,<*Cstring xPrinterName>)
res byte(return:benign)
PRINTER_ATTRIBUTE_DEFAULT       Equate(4)
PRINTER_INFO_2Type Group,type
pServerName     long !cstring if long unless noted otherwise 
pPrinterName    long 
pShareName      long
pPortName       Long
pDriverName     Long
pComment        long
pLocation       long
pDevMode        long    !LPDEVMODE
pSepFile        long
pPrintProcessor     long
pDatatype       long
pParameters     long 
pSecurityDescriptor    Long !PSECURITY_DESCRIPTOR
Attributes      ulong
Priority        ulong
DefaultPriority ulong
StartTime       ulong
UntilTime       ulong
Status          ulong
cJobs           ulong
AveragePPM      ulong
    end
printername     cstring(256),auto
hPrinter        long,auto
cbNeeded        ulong,auto
hglobal         unsigned(0)
lpglobal        long,auto
Printer_Info_2  &Printer_Info_2Type
  code
  !Open a printer - return a hprinter for inputvalues of popPtrDlg, printername
  If omitted(2) then clear(printerName) Else PrinterName = xPrinterName.
  iF SELF.ISNT AND ~POPPRTDLG THEN
    RETURN SELF.SETDEFAULTPRINTERNT(PRINTERNAME)
  END
  hPrinter = SELF.GethPrinter(PopPrtDlg, PrinterName) 
  If ~hprinter then res=Return:fatal;do ProcedureReturn.

  If SELF.isNT then
    CLOSEPRINTER(HPRINTER)
    Return SELF.SetDefaultPrinterNT(PrinterName)
  end
 
  !Get the printer info
  If SELF.GetPrinterInfo(hPrinter, hglobal, lpGlobal, cbNeeded)  then
    Res= Return:Fatal
    Do ProcedureReturn
  end


  !Set the pointer
  Printer_Info_2 &= (lpGlobal)

  !see if it is default already
  If band(Printer_Info_2.Attributes, Printer_Attribute_Default) then
    do ProcedureReturn !is default already
  end

  !Set as default printer
  Printer_Info_2.Attributes = Bor(Printer_Info_2.Attributes, Printer_Attribute_Default)

  !tell windows - write the printer info junk back to windows, pass a 0 or null command
  If SELF.SetPrinterInfo(hprinter,lpglobal,0) then
    Res=Return:Fatal
  end
  do ProcedureReturn
ProcedureReturn routine
  If hglobal then globalfree(hglobal).
  If hprinter then closeprinter(hprinter).
  Return(Res)

EnumPrtClType.SetPrinterInfo Procedure(unsigned hprinter, long lpglobal, long command)!,byte
NoErrorPrinter bool,auto
  Code
  NoErrorPrinter = SetPrinter(hprinter,| !printer of interested
                                2,| !level of info structure
                                lpGlobal,| !data
                                Command) !command
  If ~NoErrorPrinter then Return Return:fatal Else return return:benign.


EnumPrtClType.GetPrinterInfo Procedure(unsigned hprinter, *unsigned hglobal, *long lpGlobal, *ulong cbNeeded)!,byte
NoErrorPrinter bool,auto
errorprinter    ulong,auto
res byte(return:benign)
  code
  Clear(hglobal)
  NoErrorPrinter = GetPrinter(hprinter,| !printer of interest
                                 2,| !level of printer info requested
                                 0,| !address of data
                                 0,| !size of data
                                 Address(cbNeeded))
  If NoErrorPrinter or ~cbNeeded then
    !no error reported even though no memory allocated - means no jobs
    Res =Return:Fatal !no jobs
    do ProcedureReturn
  end

  !Get the error - should be insufficent buffer
  ErrorPrinter = GetLastError()

  !If the problem is no memory, allocate some and try again
  If ErrorPrinter = 122 !Error code of insufficent buffer then
    hGlobal = GlobalAlloc(42H,cbNeeded)
    If ~hglobal then res=Return:Fatal;do procedureReturn.
    lpGlobal = GlobalLock(hglobal)
    If ~lpGlobal then res=Return:Fatal;do procedureReturn.
    NoErrorPrinter = GetPrinter(hprinter,| !printer of interest
                                 2,| !level of printer info requested
                                 lpGlobal,| !address of data
                                 cbNeeded,| !size of data
                                 Address(cbNeeded))
  Else
    Res = Return:Fatal !unknown error
    Clear(NoErrorPrinter)
    Do ProcedureReturn
  end
ProcedureReturn Routine
  Return(Res)
EnumPrtClType.SetDefaultPrinterNT          Procedure(*cstring printerName)!,byte
DeviceName  cstring(128),auto
driverName  cstring(128),auto
PrinterPort cstring(128),auto
sectionlabel cstring('PrinterPorts')
headerlabel  cstring('Device')
NullStr      cstring('')
lpbuffer       string(128)
deviceLine   cstring(256),auto
bufferlen    long
commapos    long
lastcommapos long
  code
  bufferLen = getProfileString(SectionLabel, PrinterName, NullStr, address(lpbuffer), size(lpbuffer))
  If ~bufferlen then
     !printer not found
     Return Return:fatal
  end
  commapos=instring(',',lpbuffer[1 : bufferlen],1,1)
  If commapos then
    DriverName=Clip(Left(lpbuffer[1 : commapos-1]))
    lastCommapos=commapos
    CommaPos = instring(',',lpbuffer[1 : bufferlen],1,LastCommaPos+1)
    If CommaPos then
       PrinterPort=clip(Left(lpbuffer[LastCommaPos+1 : commapos-1]))
    else
      Return Return:Fatal !No Port
    end
  else
    Return Return:Fatal !no driver
  end
  SectionLabel = 'windows'
  DeviceLine = Printername & ',' & DriverName & ',' & PrinterPort
  If ~WriteProfileString(SectionLabel, HeaderLabel, DeviceLine) then
    return return:fatal
  end
  SendMessage(0FFFFH,1AH,0,Address(SectionLabel))
  return Return:Benign
EnumPrtClType.GetDefaultPrinterNT      Procedure()!,byte
SectionLabel cstring('windows')
headerLabel cstring('device')
commas cstring(',,,')
lpbuffer string(256),auto
bufferlen long,auto
commapos long,auto
  code  
  Bufferlen=GetProfileString(SectionLabel,Headerlabel,commas,address(lpbuffer),size(lpbuffer))
  commapos = instring(',',lpbuffer[1 : bufferlen],1,1)
  If commapos>0 then
    SELF.defaultPrinterNT=upper(clip(left(lpbuffer[1 : commapos-1])))
    Return Return:benign
  else
    Clear(SELF.defaultPrinterNT)
    Return Return:Fatal
  end
  
EnumPrtClType.IsDefaultPrinterNT       Procedure(*cstring PrinterName)!,byte
  code
  If Upper(printername)=SELF.defaultprinterNT then
    Return true
  end
  Return false
  

EnumPrtClType.TakeError procedure(string pMsg, <long pApiErrorcode>)
!purpose: save the last error msg and if passed apierrorcode.
!         if debugmode =0 display nothing
!         if debugmode =1 only show errors in a message box
apiErrorStr string(80),auto
  code
  SELF.Errorstr=pmsg
  if ~omitted(pApiErrorCode) then
    SELF.ApiErrorCode=pApiErrorcode
    if pApiErrorcode then
      IF ~SELF.FormatErrMsg( apiErrorStr, pApiErrorCode ) then
        pMsg = clip( SELF.ErrorStr ) & apierrorstr
      end
    end
    
  end
  if SELF.Debugmode<>0
    Message( SELF.ErrorStr )
  end
  return
  
EnumPrtClType.FormatErrMsg            procedure(*string pmsg,long EC)!,byte,proc
lpMsgBuf  long,auto  !Address of message string formated by FormatMessage Call
lenMsgBuf long,auto  !char in cstring return by formatMessage
res       byte(3)
  code
  clear( pMsg )
  If FormatMessage(1100H, | !Format_Message_Allocate_Buffer + Format_message_From_System
                   0, EC,0,Address(lpMsgBuf),0,0)
    lenMsgBuf = lstrlen(lpmsgBuf)
    If lenMsgBuf then
      lenMsgBuf = choose(lenMsgBuf>size( pMsg ), size( pMsg ), lenmsgbuf)
      memcpy(Address( pMsg ), lpMsgBuf, lenMsgBuf)
      res=0
    end
    If lpMsgBuf then  LocalFree(lpMsgBuf). !clean up allocated memory
  end
  Return res

  
EnumPrtClType.PrinterNotifications procedure( LONG JOBTHREAD )
threadid                      long !not used, satisify prototype
Res                           byte( return:Fatal )  !method return value 0=good
PrinterQueue                  PrinterQueueType
hEventShutDown                Long( 0 )  !Event object - reset, manual-reset, set to end monitoring
NumberOfPrinters              Long !number of printers enumerated, after user edits
PrinterIndex                  long !loop counter

  code
  If ~SELF.PrinterNotificationsQ &= NULL then
     SELF.TakeError( 'PrinterNotifications method can only be called once.  Go away.')
     do procret
  end
  
  !Queue of printers being watched
  SELF.PrinterNotificationsQ &= New PrinterNotificationsQType
  SELF.JobAttribQ  &= New JobAttribQType
  If SELF.PrinterNotificationsQ &= NULL or |
     SELF.JobAttribQ &= NULL then
    SELF.TakeError( 'Out of memory' )
    do ProcRet
  end
  
  SELF.JobAttribQ.JobAttrib   = JOB_NOTIFY_FIELD_PRINTER_NAME
  SELF.JobAttribQ.Description = 'PRINTER NAME'
  SELF.JobAttribQ.DataType    = JobAttribDataType:String
  do SaveAttrib
  
  SELF.JobAttribQ.JobAttrib   = JOB_NOTIFY_FIELD_Machine_Name
  SELF.JobAttribQ.Description = 'MACHINE NAME'
  SELF.JobAttribQ.DataType    = JobAttribDataType:String
  do SaveAttrib
  
  SELF.JobAttribQ.JobAttrib   = JOB_NOTIFY_FIELD_USER_NAME
  SELF.JobAttribQ.Description = 'USER NAME'
  SELF.JobAttribQ.DataType    = JobAttribDataType:String
  do SaveAttrib
  
  SELF.JobAttribQ.JobAttrib   = JOB_NOTIFY_FIELD_STATUS
  SELF.JobAttribQ.Description = 'STATUS'
  SELF.JobAttribQ.DataType    = JobAttribDataType:long
  do SaveAttrib
  
  SELF.JobAttribQ.JobAttrib   = JOB_NOTIFY_FIELD_STATUS_STRING
  SELF.JobAttribQ.Description = 'STATUS_STRING'
  SELF.JobAttribQ.DataType    = JobAttribDataType:String
  do SaveAttrib
  
  SELF.JobAttribQ.JobAttrib   = JOB_NOTIFY_FIELD_DOCUMENT
  SELF.JobAttribQ.Description = 'DOCUMENT'
  SELF.JobAttribQ.DataType    = JobAttribDataType:String
  do SaveAttrib
  
  SELF.JobAttribQ.JobAttrib   = JOB_NOTIFY_FIELD_SUBMITTED
  SELF.JobAttribQ.Description = 'SUBMITTED'
  SELF.JobAttribQ.DataType    = JobAttribDataType:DateTime
  do SaveAttrib
  
  SELF.JobAttribQ.JobAttrib   = JOB_NOTIFY_FIELD_TOTAL_PAGES
  SELF.JobAttribQ.Description = 'TOTAL PAGES'
  SELF.JobAttribQ.DataType    = JobAttribDataType:long
  do SaveAttrib
  
  SELF.JobAttribQ.JobAttrib   = JOB_NOTIFY_FIELD_PAGES_PRINTED
  SELF.JobAttribQ.Description = 'PAGES PRINTED'
  SELF.JobAttribQ.DataType    = JobAttribDataType:long
  do SaveAttrib
  
  SELF.JobAttribQ.JobAttrib   = JOB_NOTIFY_FIELD_TOTAL_BYTES
  SELF.JobAttribQ.Description = 'TOTAL BYTES'
  SELF.JobAttribQ.DataType    = JobAttribDataType:long
  do SaveAttrib
  
  
  !CreateEvent parameters produce: Manual Reset, Initially NOT signaled ( ie reset ), Unnamed event object
  SELF.hEventShutDown = CreateEvent( 0, 1, 0, 0 )
  If ~SELF.hEventShutDown then
    SELF.TakeError('Error creating an event.')
    Do ProcRet !abort
  end
  
  !get a printer list and offer to let the user remove items
  SELF.GetPrinterList( PrinterQueue )
  If SELF.EditPrintNotificationList( printerQueue, SELF.JobAttribQ ) <> Return:Benign then
    SELF.TakeError( 'PrinterNotifications Cancelled.')
    Do Procret
  end
  
  


  NumberOfPrinters = Records( PrinterQueue )
  Loop PrinterIndex = 1 to NumberOfPrinters
    Get( PrinterQueue, PrinterIndex )


    !add to PrineterNotificationsQ
    Clear( SELF.PrinterNotificationsQ )
    SELF.PrinterNotificationsQ.PrinterName = PrinterQueue.PrinterName
    Add( SELF.PrinterNotificationsQ )
    If errorcode() then
      SELF.TakeError('Out of memory')
      do procret
    end
    
    !open the printer
    if SELF.OpenPrinter( PrinterQueue.PrinterName, Address( SELF.PrinterNotificationsQ.hPrinter ) ) = 0 then
      !didnt get a hprinter so skip it
      SELF.ApiErrorCode = GetLastError()
      SELF.TakeError( 'Error opening printer: '& PrinterQueue.PrinterName, SELF.ApiErrorCode )
      cycle
    end
    Put( SELF.PrinterNotificationsQ )
    
    SELF.MyDataClass &= NULL
    SELF.MyDataClass &= New MyDataClassType
    If SELF.MyDataClass &= NULL then
      SELF.TakeError( 'Out of memory' )
      do procret
    end
    SELF.MyDataClass.hEventShutDown = SELF.hEventShutDown
    SELF.MyDataClass.JobAttribQ    &= SELF.JobAttribQ
    SELF.MyDataClass.hPrinter       = SELF.PrinterNotificationsQ.hprinter
    SELF.MyDataClass.DwFlags        = PRINTER_CHANGE_ADD_JOB
    SELF.MyDataClass.JobThread      = JobThread
    
    !create a thread that we get the hthread for so we can know when the thread ends
    SELF.PrinterNotificationsQ.hThread = CreateThread( 0, 0, Address( MonitorProc ), Address( SELF.MyDataClass ), 0, ThreadID )    
    If ~SELF.PrinterNotificationsQ.hThread then
      SELF.ApiErrorCode = GetLastError()
      SELF.TakeError( 'Error creating a thread', SELF.ApiErrorCode )
      Do ProcRet
    end  
    Put( SELF.PrinterNotificationsQ )
    SELF.MyDataClass &= NULL !the new thread has to dispose of it
    
    
  end  !loop setting up notifications
    
    
  !Success
  Res = return:benign
  do procret
    
ProcRet routine
  If res <> Return:Benign then
    SELF.KillNotifications()
  end
  return res
  
SaveAttrib Routine
  Add( SELF.JobAttribQ )
  If ErrorCode() then
    SELF.TakeError( 'Out of Memory' )
    do Procret
  end



EnumPrtClType.KillNotifications procedure()
!CLEAN UP
! CLOSE HPRINTER HANDLES
! KILL THREADS
! CLOSE HTHREADS
! CLOSE HEVENTSHUTDOWN
! DISPOSE MYDATACLASS AND PRINTERNOTIFICATIONSQ and jobattribQ
Recs                      Long,auto         !Queue record count
I                         Long,auto         !loop counter
TicksPerDay               equate(8640000)   !number of 100ths of a second on one day.
MaxTime                   Equate( 6000 )    !1 minute - max time to wait for sentinal file
StartTime                 long,auto         !thread shutdown process timeout
ElapsedTime               long,auto         !DITO
ExitCodeTerminated        long(0)           !exit code of a thread that is terminated by terminate thread - not checked or used at present
  code
  If SELF.PrinterNotificationsQ &= NULL then Return; End !nothing to clean up - called twice or printernotifications never called
  If SELF.hEventShutdown then
    If SetEvent( SELF.hEventShutdown ) = 0 then
      SELF.ApiErrorCode = GetLastError()
      SELF.TakeError( 'Error starting printer notification shutdown.', SELF.ApiErrorCode )
    end
  end
  StartTime = Clock()
  Loop
    Recs = Records( SELF.PrinterNotificationsQ )
    If recs = 0 then break; end
    Loop I = Recs to 1 by -1 
      Get( SELF.PrinterNotificationsQ, I )
      If SELF.PrinterNotificationsQ.hPrinter then
        ClosePrinter( SELF.PrinterNotificationsQ.hPrinter )
        clear( SELF.PrinterNotificationsQ.hPrinter )
        Put( SELF.PrinterNotificationsQ )
      End
      If SELF.PrinterNotificationsQ.hThread = 0 or |
         WaitForSingleObject( SELF.PrinterNotificationsQ.hThread, 0 ) <> Wait_TimeOut then
        If SELF.PrinterNotificationsQ.hThread <> 0 then CloseHandle( SELF.PrinterNotificationsQ.hThread ); end
        delete( SELF.PrinterNotificationsQ )
      end
    end
    ElapsedTime = Clock() - StartTime
    If ElapsedTime < 0 then ElapsedTime += TicksPerDay; end
    If ElapsedTime > MaxTime then
      SELF.TakeError( 'Exceeded max time shutting down - will terminate threads.')
      Do HardWay
      break
    end
  end
  IF SELF.hEventShutDown then Closehandle( SELF.hEventShutDown ); Return; end
  clear( SELF.hEventShutDown )
  Dispose( SELF.MyDataClass )
  Dispose( SELF.PrinterNotificationsQ )
  Dispose( SELF.JobAttribQ )
  Return
  
HardWay routine
!Terminate the threads
    Recs = Records( SELF.PrinterNotificationsQ )
    If recs = 0 then Exit; end
    Loop I = Recs to 1 by -1 
      Get( SELF.PrinterNotificationsQ, I )
      TerminateThread( SELF.PrinterNotificationsQ.hthread, ExitCodeTerminated )
      closeHandle( SELF.PrinterNotificationsQ.hthread )
    end
    Free(  SELF.PrinterNotificationsQ )
    Exit
  
EnumPrtClType.EditPrintNotificationList Procedure( printerQueueType PrinterQ, JobAttribQType JobAttribQ )!,byte,virtual
!return non-zero to exit, remove printers you dont want to watch - dont add any
! screw with jobattrib if you want
  code
  !virtual
  return Return:Benign
  
MonitorProc procedure( long lpMyDataClass )
  code
  AttachThreadToClarion( 1 )
  Return MonitorProc2( lpMyDataClass )
  
MonitorProc2        procedure( long lpMyDataClass ) 
MyDataClass          &MyDataClassType   !class passed in by address with input data
JobNotificationClass &JobNotificationClassType  !class passed out with ouput data
JobIDQ               queue  !if a job not in this queue then pause it - maybe there is a status we can use instead
JobID                long
                     end
ExitCode            long !not checked at present so value really doesnt matter
lpPrinterNotifyInfo long !api fills this with a pointer to info about the change
handlesArray        group,pre()  !handles array for waitformultipleobjects - 2 elements in the 'array'
hWait               long
hEventShutdown      long
                    end
PrinterNotifyOptions group
Version              long !must be 2 
Flags                long !0 the first time, PRINTER_NOTIFY_OPTIONS_REFRESH after
count                long !number of Printer
lpPrinter_Notify_Options_Type         long !address of an array of shorts
              end
PRINTER_NOTIFY_OPTIONS_TYPE Group
FieldType   ushort
Reserved0   ushort
Reserved1   long
reserved2   long
count       long
lpTypesArray long
    end
                
TypesArray           &String  !array of job attributes to monitor - array of shorts
SizeOfShort          equate( 2 )
lpTypesArray         long,auto !pointer to typesarray that gets incremented for convenicen
I                    long,auto !loop counter
PRINTER_NOTIFY_OPTIONS_REFRESH  Equate( 1 )



!structures for data RETURNED from the notification
Printer_Notify_InfoType Group,Type
Version long
flags   long
count   long
lpArray long  ! array of Printer_Notify_Info_Data structures  
    end
Printer_Notify_Info_DataType Group,Type
TheType         ushort !JOB_NOTIFY_TYPE - either printer_Notify_Type or Job_Notify_Type
TheField        ushort !Job_Notify_Field_* - see MyDataClass.JobAttribQ.
Reserved        long
id              long   !job identifier
cbString        long
lpszString      long
LongData1       long, over( cbString )
LongData2       long, over( lpszString )
                end

PNI             &Printer_Notify_InfoType
PNI_Data        &Printer_Notify_Info_DataType
L               long !string length to ensure dont overrun a buffer
lpdata          long !memory pointer that is incremented as we move thru the array of returned data
TheStatus       long !holds the dword status for conversion to a string

!date time stuff
SYSTEMTIME      GROUP              !System time struct for conversion from system to clarion datae and time
wYear            ushort
wMonth           ushort
wDayOfWeek       ushort
wDay             ushort
wHour            ushort
wMinute          ushort
wSecond          ushort
wMilliseconds    ushort
                END
TIME_ZONE_INFORMATION   GROUP
Bias                    LONG
StandardName            byte,dim(64) !will clear to 0's
StandardDate            LIKE(systemTIME)
StandardBias            LONG
DaylightName            byte,dim(64)
DaylightDate            LIKE(SYSTEMTIME)
DaylightBias            LONG
                        END
TZ_Info                 long,auto
Bias                    long,auto

ResumeRequired         byte, auto !if true the UI should ask questions then resume the print job

  code
  !validate the input
  if lpMyDataClass = 0 then Return ExitCode; end
    
  !convert the long to a class
  MyDataClass &= ( lpMyDataClass )
  
  !save the hEventShutdown in the handlearray used by WaitforMultipleObjects
  HandlesArray.hEventShutdown = MyDataClass.hEventShutDown
  
  !Fill in the PrinterNotifyOptions and PrinterNotifyOptionsType groups required for FindFirstPrinterChangeNotification
  PrinterNotifyOptions.Version = 2 !Required value from msdn
  PrinterNotifyOptions.Flags   = 0 !field is ignored
  PrinterNotifyOptions.Count   = 1  !we only want job info not printer info as well so this is 1
  
  !Pointer to the group that describes the job options we want
  PrinterNotifyOptions.lpPrinter_Notify_Options_Type = Address( Printer_Notify_Options_Type )
  PRINTER_NOTIFY_OPTIONS_TYPE.FieldType = JOB_NOTIFY_TYPE  !required value for job info
  
  !load all the attributes stored in MyDataClass.JobAttribQ into an array of shorts
  
  !New() the array 
  PRINTER_NOTIFY_OPTIONS_TYPE.Count   = Records( MyDataClass.JobAttribQ )
  TypesArray &= New string( PRINTER_NOTIFY_OPTIONS_TYPE.Count * SizeOfShort )
  If TypesArray &= NULL then do ProcRet end
  lpTypesArray = address( TypesArray )
  PRINTER_NOTIFY_OPTIONS_TYPE.lpTypesArray = address( TypesArray )
  
  
  !loop thru the JobAttribQ and put each attribute into the array
  Loop I = 1 to PRINTER_NOTIFY_OPTIONS_TYPE.Count
    Get( MyDataClass.JobAttribQ, I )
    memcpy( lpTypesArray, Address( MyDataClass.JobAttribQ.JobAttrib ), SizeOfShort )
    lpTypesArray += SizeOfShort
  end
  
  !get some TimeZone info for GMT to local time conversion
  TZ_Info=GetTimeZoneInformation(Address(TIME_ZONE_INFORMATION))
  Clear(Bias) !Hours from GMT
  If TZ_Info = 2 !daylight
    bias = (TIME_ZONE_INFORMATION.bias+TIME_ZONE_INFORMATION.daylightbias)/60
  Elsif tz_Info = 1 !std
    bias = (TIME_ZONE_INFORMATION.bias+TIME_ZONE_INFORMATION.Standardbias)/60
  End
  
  !Now were ready - call FindFirstPrinterChangeNotification and then wait for it to tell us something
  HandlesArray.hWait = FindFirstPrinterChangeNotification( MyDataClass.hPrinter, MyDataClass.DwFlags, 0, Address( PrinterNotifyOptions ) )
  Loop
    
    !Wait until the program is ending or there is printer data
    case WaitForMultipleObjects( 2, address( handlesArray ), 0, Infinite )
    of Wait_Object_0 + 1
      !program is ending
      break
      
    of Wait_Object_0 
    
      !we have data to process
      PrinterNotifyOptions.Flags = 0 !PRINTER_NOTIFY_OPTIONS_REFRESH
      If FindNextPrinterChangeNotification( HandlesArray.hwait, address( MyDataClass.DwFlags ), Address( PrinterNotifyOptions ), lpPrinterNotifyInfo ) = 0 then
        !error - end thread
        break
      end

      !New() a queue and a class to wrap the queue so we can store the new printer data in it.
      !the JobNotificationClass is just used to hold the NewJobInfoQ
      JobNotificationClass &= New JobNotificationClassType
      JobNotificationClass.NewJobInfoQ &= New NewJobInfoQType

      !this is where we get the info from lpPrinterNotifyInfo and put into NewJobInfoQ
      PNI &= ( lpPrinterNotifyInfo )
      lpData = Address( PNI.lpArray )
      Loop PNI.Count Times
        
        !get a pointer info the array of data for a single attribute
        PNI_DATA &= ( lpData )
        lpdata += Size( Printer_Notify_Info_DataType ) !for next time
        
        !skip the attribute if thetype is wrong
        If PNI_Data.TheType <> JOB_NOTIFY_TYPE then 
          cycle
        end
        
        JobIDQ.JobID = PNI_DATA.ID
        Get( JobIdQ, JobIDQ.JobID )
        If ErrorCode() then
          if SetJob( MyDataClass.hprinter, JobIdQ.JobID, 0, 0, JOB_CONTROL_PAUSE ) = 0 then
            !probably should log this failure some where
            ResumeRequired = false
          else
            Add( JobIDQ )
            ResumeRequired = True
          end
        Else
          ResumeRequired = false
        end
        
        !load up JobNotificationClass.NewJobInfoQ


        !find the jobattrib in our MyDataClass.jobAttribq 
        ! which has info on how to decode the data returned like it's datatype
        JobNotificationClass.NewJobInfoQ.JobID = PNI_DATA.ID
        JobNotificationClass.NewJobInfoQ.JobAttrib = PNI_Data.TheField
        JobNotificationClass.NewJobInfoQ.hPrinter = MyDataClass.hPrinter
        JobNotificationClass.NewJobInfoQ.ResumeRequired = ResumeRequired
        MyDataClass.JobAttribQ.JobAttrib = PNI_Data.TheField
        Get( MyDataClass.JobAttribQ, MyDataClass.JobAttribQ.JobAttrib )
        If ErrorCode() then
          JobNotificationClass.NewJobInfoQ.Description = 'Unknown (' & PNI_Data.TheField & ')'
          Clear( MyDataClass.JobAttribQ.DataType )
        else
          JobNotificationClass.NewJobInfoQ.Description = MyDataClass.JobAttribQ.Description
        end
        JobNotificationClass.NewJobInfoQ.DataType  = MyDataClass.JobAttribQ.DataType
        
        
        !now, based on datatype from MyDataClass.JobAttribQ, read the data into the queue
        Case MyDataClass.JobAttribQ.DataType
        Of JobAttribDataType:Long
          !The data is a simple long
          !but for job status do a lookup via a routine to get a descriptive string
          if PNI_Data.TheField = JOB_NOTIFY_FIELD_STATUS
            Clear( JobNotificationClass.NewJobInfoQ.StringValue )
            TheStatus = PNI_Data.LongData1
            do GetStatusString
          else
            JobNotificationClass.NewJobInfoQ.StringValue = PNI_DATA.LongData1
          end
          JobNotificationClass.NewJobInfoQ.LongVal = PNI_Data.LongData1
          JobNotificationClass.NewJobInfoQ.TheDate = 0
          JobNotificationClass.NewJobInfoQ.TheTime = 0
          
          
        of JobAttribDataType:DateTime
          !The data is a datetime - retrieve the systemtime structure passed and convert to clarion date time
          !use timezone bias calc earlier to convert to local time
          MemCpy( Address( SystemTime ), PNI_Data.lpszstring , size( systemtime ) )
          JobNotificationClass.NewJobInfoQ.LongVal = 0
          if SystemTime.wHour<bias then
            !borrow 24hr from the day
            SystemTime.WHour+=24
            SystemTime.wDay-=1
          end
          JobNotificationClass.NewJobInfoQ.TheTime     = 100*(systemtime.wSecond + SystemTime.wMinute*60 + (SystemTime.wHour-Bias)*3600)+1 + Systemtime.wMilliseconds/10 
          JobNotificationClass.NewJobInfoQ.TheDate     = Date(systemTime.wMonth, SystemTime.wday, SystemTime.wYear)
          JobNotificationClass.NewJobInfoQ.StringValue = format( JobNotificationClass.NewJobInfoQ.TheDate, @D2 ) & ' ' & format( JobNotificationClass.NewJobInfoQ.TheTime, @T6 ) 
          
          
        of JobAttribDataType:String
          !it's string data - appears to be ansi
          clear( JobNotificationClass.NewJobInfoQ.StringValue )
          L = lStrLen( PNI_Data.lpszstring )
          If L = 0 then cycle; end !no point in an entry with no text
          If L > Size( JobNotificationClass.NewJobInfoQ.StringValue )
            L = Size( JobNotificationClass.NewJobInfoQ.StringValue )
          end 
          Memcpy( Address( JobNotificationClass.NewJobInfoQ.StringValue ), PNI_Data.lpszstring, L )
          JobNotificationClass.NewJobInfoQ.LongVal = 0
          JobNotificationClass.NewJobInfoQ.TheDate = 0
          JobNotificationClass.NewJobInfoQ.TheTime = 0
          
        else
          !didnt recognize this one 
          JobNotificationClass.NewJobInfoQ.StringValue = 'Invalid'
          JobNotificationClass.NewJobInfoQ.LongVal = 0
          JobNotificationClass.NewJobInfoQ.TheDate = 0
          JobNotificationClass.NewJobInfoQ.TheTime = 0
        end
        Add( JobNotificationClass.NewJobInfoQ )
      end


      !send the data back to the window where it is displayed 
      if ~Records( JobNotificationClass.NewJobInfoQ ) then
        dispose( JobNotificationClass.NewJobInfoQ )
        dispose( JobNotificationClass )
      else
        !use notify to tell clarion to show the info
        NOTIFY ( 0, MyDataClass.JobThread, Address( JobNotificationClass ) )
        JobNotificationClass &= NULL !the class and queue have to be disposed of by the notified thread
      end
      
      !free the api copy of the data 
      FreePrinterNotifyInfo( lpPrinterNotifyInfo )


    Else
      !Strange error
      break
    end
  end
  
  do ProcRet 
ProcRet routine
  Dispose( TypesArray )
  if HandlesArray.hwait then FindClosePrinterChangeNotification( HandlesArray.hwait ); end
  Dispose( MyDataClass )
  Return ExitCode
  
GetStatusString Routine  
  data
LenStatus Long,auto
  code
  clear( lenStatus )     
  If Band( TheStatus,JOB_STATUS_PAUSED) ! Equate(001H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'Paused'
    LenStatus+=1
  end
  If Band( TheStatus, JOB_STATUS_ERROR)  ! Equate(002H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'Error'
    LenStatus+=1
  end
  If Band( TheStatus, JOB_STATUS_DELETING)  !Equate(004H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'Deleting'
    LenStatus+=1
  end
  If Band( TheStatus, JOB_STATUS_SPOOLING)  ! Equate(008H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'Spooling'
    LenStatus+=1
  end
  If Band( TheStatus, JOB_STATUS_PRINTING)  ! Equate(010H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'Printing'
    LenStatus+=1
  end
  If Band( TheStatus, JOB_STATUS_OFFLINE)   ! Equate(020H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'OffLine'
    LenStatus+=1
  end
  If Band( TheStatus, JOB_STATUS_PAPEROUT)  ! Equate(040H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'Out of Paper'
    LenStatus+=1
  end
  If Band( TheStatus, JOB_STATUS_PRINTED)   ! Equate(080H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'Completed'
    LenStatus+=1
  end
  If Band( TheStatus, JOB_STATUS_DELETED)   ! Equate(100H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'Deleted'
    LenStatus+=1
  end
  If Band( TheStatus, JOB_STATUS_BLOCKED_DEVQ) !  Equate(200H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'Blocked'
    LenStatus+=1
  end
  If Band( TheStatus, JOB_STATUS_USER_INTERVENTION)  !  Equate(400H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'User Intervention Required'
    LenStatus+=1
  end
  If Band( TheStatus, JOB_STATUS_RESTART)   !  Equate(800H)
    JobNotificationClass.NewJobInfoQ.StringValue = Clip(JobNotificationClass.NewJobInfoQ.StringValue) & choose(lenStatus=0,'',' - ') & 'Restarting'
    LenStatus+=1
  end
  Exit
  
                                    

  